# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Face::V1_0
  module Models
    #
    # Face list object.
    #
    class FaceList < MetaDataContract

      include MsRestAzure

      # @return [String] FaceListId of the target face list.
      attr_accessor :face_list_id

      # @return [Array<PersistedFace>] Persisted faces within the face list.
      attr_accessor :persisted_faces


      #
      # Mapper for FaceList class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'FaceList',
          type: {
            name: 'Composite',
            class_name: 'FaceList',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                constraints: {
                  MaxLength: 128
                },
                type: {
                  name: 'String'
                }
              },
              user_data: {
                client_side_validation: true,
                required: false,
                serialized_name: 'userData',
                constraints: {
                  MaxLength: 16384
                },
                type: {
                  name: 'String'
                }
              },
              recognition_model: {
                client_side_validation: true,
                required: false,
                serialized_name: 'recognitionModel',
                default_value: 'recognition_01',
                type: {
                  name: 'String'
                }
              },
              face_list_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'faceListId',
                constraints: {
                  MaxLength: 64,
                  Pattern: '^[a-z0-9-_]+$'
                },
                type: {
                  name: 'String'
                }
              },
              persisted_faces: {
                client_side_validation: true,
                required: false,
                serialized_name: 'persistedFaces',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PersistedFaceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PersistedFace'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
